-- name: [CS] Executable M
-- description: A mod that adds Executable M, also known as All Father, from Mario.EXE Reimagined.\n\ \n\Mod creator: \\#75e8ff\\steven.\\#ffffff\\\n\Owner of Exe M: \\#fe0002\\Ultra Inferno

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]

local TEXT_MOD_NAME = "Executable M"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_EXECUTABLE_M = smlua_model_util_get_id("exem_geo") -- Located in "actors"

local EXEM_LIFE_ICON = get_texture_info("exem-hud") -- Located in "textures"
--local TEX_CUSTOM_STAR_ICON = get_texture_info("exclamation-icon") -- Located in "textures"

-- All Located in "sound"
local EXEM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = 'exem-owch.ogg',
    [CHAR_SOUND_DOH] = 'exem-owh.ogg',
    [CHAR_SOUND_DROWNING] = 'exem-drowning.ogg',
    [CHAR_SOUND_DYING] = 'exem-death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'exem-hah.ogg',
    [CHAR_SOUND_HAHA] = 'exem-haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'exem-haha.ogg',
    [CHAR_SOUND_UH] = 'exem-ungh.ogg',
    [CHAR_SOUND_UH2] = 'exem-ungh.ogg',
    [CHAR_SOUND_UH2_2] = 'exem-ungh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'exem-laugh.ogg',
    [CHAR_SOUND_HOOHOO] = 'exem-hoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'exem-mamamia.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'exem-here-i-come.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'exem-showtime.ogg',
    [CHAR_SOUND_ON_FIRE] = 'exem-burned.ogg',
    [CHAR_SOUND_OOOF] = 'exem-yeowch.ogg',
    [CHAR_SOUND_OOOF2] = 'exem-yeowch.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'exem-hah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'exem-wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'exem-yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'exem-so-long.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'exem-woohohohoo.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'exem-falling.ogg',
    [CHAR_SOUND_WAH2] = 'exem-hah.ogg',
    [CHAR_SOUND_WHOA] = 'exem-woah.ogg',
    [CHAR_SOUND_YAHOO] = 'exem-yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'exem-yahoo.ogg', 'exem-wahaa.ogg', 'exem-yippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'exem-yah.ogg', 'exem-wah.ogg', 'exem-hoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'exem-yawn.ogg',
    [CHAR_SOUND_SNORING1] = 'exem-snore-1.ogg',
    [CHAR_SOUND_SNORING2] = 'exem-snore-2.ogg',
    [CHAR_SOUND_SNORING3] = {'exem-snore-1.ogg', 'exem-snore-2.ogg', 'exem-sleeptalk.ogg'},
    [CHAR_SOUND_COUGHING1] = 'exem-cough-1.ogg',
    [CHAR_SOUND_COUGHING2] = 'exem-cough-2.ogg',
    [CHAR_SOUND_COUGHING3] = 'exem-cough-3.ogg',
    [CHAR_SOUND_HRMM] = 'exem-lift.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'exem-im-a-so-sleepy.ogg',
    [CHAR_SOUND_PANTING] = 'exem-panting.ogg',
    [CHAR_SOUND_PRESS_START_TO_PLAY] = 'exem-press-start.ogg',
}

-- All Located in "actors"
local EXEM_CAPTABLE = {
    normal = smlua_model_util_get_id("exems_cap_geo"),
    wing = smlua_model_util_get_id("exems_wing_cap_geo"),
    metal = smlua_model_util_get_id("exems_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("exems_winged_metal_cap_geo"),
}

--local E_MODEL_CUSTOM_STAR = smlua_model_util_get_id("custom_model_star_geo") -- Located in "actors"

local PALETTE_CHAR = {
    [PANTS]  = "64130b",
    [SHIRT]  = "292906",
    [GLOVES] = "f3ddb4",
    [SHOES]  = "401004",
    [HAIR]   = "55180b",
    [SKIN]   = "906213",
    [CAP]    = "64130b",
    [EMBLEM]    = "64130b",
}

--[[
-- All Located in "textures"
local healthMeter = {
    label = {
        left = get_texture_info("template-hp-back-left"),
        right = get_texture_info("template-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("template-hp-pie-1"),
        [2] = get_texture_info("template-hp-pie-2"),
        [3] = get_texture_info("template-hp-pie-3"),
        [4] = get_texture_info("template-hp-pie-4"),
        [5] = get_texture_info("template-hp-pie-5"),
        [6] = get_texture_info("template-hp-pie-6"),
        [7] = get_texture_info("template-hp-pie-7"),
        [8] = get_texture_info("template-hp-pie-8"),
    }
}
]]

--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local CSloaded = false
local function on_character_select_load()
    CT_ALL_FATHER = _G.charSelect.character_add("Executable M", {"Hey, buddy!", "What're you doin' here?", "", "Ohoho, I see... You're up to run,", "jump 'n dive like Mario all over again,", "eh? Well, we're pros at that!", "Aren't we?", "C'mon! I'm ready when you are!"}, "steven. and Inferno", {r = 100, g = 19, b = 11}, E_MODEL_EXECUTABLE_M, CT_MARIO, EXEM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_EXECUTABLE_M, EXEM_CAPTABLE)
    _G.charSelect.character_add_voice(E_MODEL_EXECUTABLE_M, EXEM_VOICETABLE)
    --_G.charSelect.character_add_celebration_star(E_MODEL_EXECUTABLE_M, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_EXECUTABLE_M, PALETTE_CHAR)
    --_G.charSelect.character_add_health_meter(CT_ALL_FATHER, healthMeter)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == EXEM_VOICETABLE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == EXEM_VOICETABLE then return _G.charSelect.voice.snore(m) end
end

function hand_poses_update(m)
    if CT_ALL_FATHER == _G.charSelect.character_get_current_number() and m.playerIndex == 0 then
        local exemClawActions = {
            [CHAR_ANIM_BACKFLIP] = true,
            [CHAR_ANIM_DOUBLE_JUMP_RISE] = true,
            [CHAR_ANIM_DOUBLE_JUMP_FALL] = true,
            [CHAR_ANIM_FIRST_PUNCH] = true,
            [CHAR_ANIM_FIRST_PUNCH_FAST] = true,
            [CHAR_ANIM_SECOND_PUNCH] = true,
            [CHAR_ANIM_SECOND_PUNCH_FAST] = true,
            [CHAR_ANIM_DIVE] = true,
            [CHAR_ANIM_SLIDE_DIVE] = true,
            [CHAR_ANIM_IDLE_HEAD_LEFT] = true,
            [CHAR_ANIM_IDLE_HEAD_RIGHT] = true,
            [CHAR_ANIM_IDLE_HEAD_CENTER] = true,
            [CHAR_ANIM_RUNNING] = true
        }

        if exemClawActions[m.marioObj.header.gfx.animInfo.animID] then
            m.marioBodyState.handState = MARIO_HAND_OPEN
        end

        if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_CREDITS_WAVING then
            m.marioBodyState.handState = MARIO_HAND_HOLDING_CAP
            m.marioBodyState.capState = MARIO_HAS_DEFAULT_CAP_OFF
        end

        if m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_STAR_DANCE then
            if m.marioObj.header.gfx.animInfo.animFrame > 40 then
                m.marioBodyState.handState = MARIO_HAND_OPEN
            end
        end
    end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)
hook_event(HOOK_MARIO_UPDATE, hand_poses_update)